using FluentValidation;
using CMSMicroservice.Protobuf.Protos.Transactions;
namespace CMSMicroservice.Protobuf.Validator.Transactions;

public class DeleteTransactionsRequestValidator : AbstractValidator<DeleteTransactionsRequest>
{
    public DeleteTransactionsRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<DeleteTransactionsRequest>.CreateWithOptions((DeleteTransactionsRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
